#include "DragAndDrop.h"

#include <shellapi.h>
#pragma comment (lib,"shell32.lib")

CDragAndDrop::CDragAndDrop(HWND hWndDialog, pfFileDroppedCallBack FileDroppedCallBack,LPVOID FileDroppedCallBackUserParam)
{
    this->hWndDialog = hWndDialog;
    this->FileDroppedCallBack = FileDroppedCallBack;
    this->FileDroppedCallBackUserParam = FileDroppedCallBackUserParam;
}

CDragAndDrop::~CDragAndDrop(void)
{
}

void CDragAndDrop::Start()
{
    if (::IsBadCodePtr((FARPROC)this->FileDroppedCallBack))
        this->FileDroppedCallBack = NULL;
    ::DragAcceptFiles(this->hWndDialog,TRUE);
}
void CDragAndDrop::Stop()
{
    ::DragAcceptFiles(this->hWndDialog,FALSE);
}

// must be called by wnd proc on WM_DROPFILES messages
void CDragAndDrop::OnWM_DROPFILES(WPARAM wParam, LPARAM lParam)
{
    UNREFERENCED_PARAMETER(lParam);
    HDROP hDrop = (HDROP)wParam;


    TCHAR pszFileName[MAX_PATH];
    UINT NbFiles;
    UINT Cnt;
    POINT pt;
    HWND SubWindowHandle;

    // retrieve dialog subitem window handle
    ::DragQueryPoint(hDrop, &pt);
    ::ClientToScreen(this->hWndDialog,&pt);
    SubWindowHandle=::WindowFromPoint(pt);

    // get number of files count in the drag and drop
    NbFiles=DragQueryFile(hDrop, 0xFFFFFFFF,NULL, MAX_PATH);

    // for each dropped file
    for (Cnt=0;Cnt<NbFiles;Cnt++)
    {
        // get dropped file name
        ::DragQueryFile(hDrop, Cnt,pszFileName, MAX_PATH);

        // call callback if any
        if (this->FileDroppedCallBack)
            this->FileDroppedCallBack(SubWindowHandle, pszFileName, Cnt, this->FileDroppedCallBackUserParam);
    }

    // end current drag and drop operation
    ::DragFinish(hDrop);
}

